# coding: utf-8

"""
    Marquez

    Marquez is an open source **metadata service** for the **collection**, **aggregation**, and **visualization** of a data ecosystem's metadata.  # noqa: E501

    OpenAPI spec version: 0.1.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from marquez_codegen_client.api_client import ApiClient
from marquez_codegen_client.exceptions import (
    ApiTypeError,
    ApiValueError
)


class DatasourcesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def datasources_get(self, **kwargs):  # noqa: E501
        """List all datasources  # noqa: E501

        Returns a list of datasources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: Datasources
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.datasources_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.datasources_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def datasources_get_with_http_info(self, **kwargs):  # noqa: E501
        """List all datasources  # noqa: E501

        Returns a list of datasources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: Datasources
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method datasources_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/datasources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Datasources',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def datasources_post(self, **kwargs):  # noqa: E501
        """Create a datasource  # noqa: E501

        Creates a new datasource object. A datasource is the physical location of a dataset such as a table in PostgreSQL, or topic in Kafka. A datasource enables the grouping of physical datasets to their physical source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_post(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateDatasource create_datasource:
        :return: Datasource
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.datasources_post_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.datasources_post_with_http_info(**kwargs)  # noqa: E501
            return data

    def datasources_post_with_http_info(self, **kwargs):  # noqa: E501
        """Create a datasource  # noqa: E501

        Creates a new datasource object. A datasource is the physical location of a dataset such as a table in PostgreSQL, or topic in Kafka. A datasource enables the grouping of physical datasets to their physical source.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_post_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateDatasource create_datasource:
        :return: Datasource
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['create_datasource']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method datasources_post" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_datasource' in local_var_params:
            body_params = local_var_params['create_datasource']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/datasources', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Datasource',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def datasources_urn_get(self, urn, **kwargs):  # noqa: E501
        """Get a datasource  # noqa: E501

        Returns a datasource. An individual datasource object is identifiable by its Marquez-generated unique URN.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_urn_get(urn, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str urn: The URN of the datasource. (required)
        :return: Datasource
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.datasources_urn_get_with_http_info(urn, **kwargs)  # noqa: E501
        else:
            (data) = self.datasources_urn_get_with_http_info(urn, **kwargs)  # noqa: E501
            return data

    def datasources_urn_get_with_http_info(self, urn, **kwargs):  # noqa: E501
        """Get a datasource  # noqa: E501

        Returns a datasource. An individual datasource object is identifiable by its Marquez-generated unique URN.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.datasources_urn_get_with_http_info(urn, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str urn: The URN of the datasource. (required)
        :return: Datasource
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['urn']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method datasources_urn_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'urn' is set
        if ('urn' not in local_var_params or
                local_var_params['urn'] is None):
            raise ApiValueError("Missing the required parameter `urn` when calling `datasources_urn_get`")  # noqa: E501

        if ('urn' in local_var_params and
                len(local_var_params['urn']) > 1024):
            raise ApiValueError("Invalid value for parameter `urn` when calling `datasources_urn_get`, length must be less than or equal to `1024`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'urn' in local_var_params:
            path_params['urn'] = local_var_params['urn']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/datasources/{urn}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Datasource',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
