# coding: utf-8

"""
    Marquez

    Marquez is an open source **metadata service** for the **collection**, **aggregation**, and **visualization** of a data ecosystem's metadata.  # noqa: E501

    OpenAPI spec version: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Datasource(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'urn': 'str',
        'created_at': 'datetime',
        'name': 'str',
        'connection_url': 'object'
    }

    attribute_map = {
        'urn': 'urn',
        'created_at': 'createdAt',
        'name': 'name',
        'connection_url': 'connectionUrl'
    }

    def __init__(self, urn=None, created_at=None, name=None, connection_url=None):  # noqa: E501
        """Datasource - a model defined in OpenAPI"""  # noqa: E501

        self._urn = None
        self._created_at = None
        self._name = None
        self._connection_url = None
        self.discriminator = None

        if urn is not None:
            self.urn = urn
        if created_at is not None:
            self.created_at = created_at
        if name is not None:
            self.name = name
        if connection_url is not None:
            self.connection_url = connection_url

    @property
    def urn(self):
        """Gets the urn of this Datasource.  # noqa: E501

        The URN of the datasource.  # noqa: E501

        :return: The urn of this Datasource.  # noqa: E501
        :rtype: str
        """
        return self._urn

    @urn.setter
    def urn(self, urn):
        """Sets the urn of this Datasource.

        The URN of the datasource.  # noqa: E501

        :param urn: The urn of this Datasource.  # noqa: E501
        :type: str
        """

        self._urn = urn

    @property
    def created_at(self):
        """Gets the created_at of this Datasource.  # noqa: E501

        An [ISO-8601](https://en.wikipedia.org/wiki/ISO_8601) timestamp representing the date/time the dataset was created.  # noqa: E501

        :return: The created_at of this Datasource.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Datasource.

        An [ISO-8601](https://en.wikipedia.org/wiki/ISO_8601) timestamp representing the date/time the dataset was created.  # noqa: E501

        :param created_at: The created_at of this Datasource.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def name(self):
        """Gets the name of this Datasource.  # noqa: E501

        The name of the datasource.  # noqa: E501

        :return: The name of this Datasource.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Datasource.

        The name of the datasource.  # noqa: E501

        :param name: The name of this Datasource.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def connection_url(self):
        """Gets the connection_url of this Datasource.  # noqa: E501

        The url to be used to connect to the datasource.  # noqa: E501

        :return: The connection_url of this Datasource.  # noqa: E501
        :rtype: object
        """
        return self._connection_url

    @connection_url.setter
    def connection_url(self, connection_url):
        """Sets the connection_url of this Datasource.

        The url to be used to connect to the datasource.  # noqa: E501

        :param connection_url: The connection_url of this Datasource.  # noqa: E501
        :type: object
        """

        self._connection_url = connection_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Datasource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
